
/*  
Orientation Tree Implementation
Jon Feldman, Guy Even
Summer, 2000
*/
//#define DEBUG
//#define DEBUG2
//#define DEBUG3
//#define DEBUG4
//#define DEBUG5
//#define PRINT_OUT_PARTITION
//#define EVAL_LOCAL_IMPROVE
//#define OVERFLOW_TEST
//#define OUTER_CUT_INFO

//#define LOCAL_COST_AT_ROOT
//#define COST_TEST
#define LOCAL_IMPROVE        //applies local improvement
#define OUTPUT_PERMUTATION  //outputs the permutation

#define RANDOM_CUT     //decides which kind of cut to select in the local
//#define MINIMUM_CUT  //improvement phase

#define LINEAR_ARRANGEMENT   //Define if we are solving linear arrangement
//#define CUTWIDTH           //Define if we are solving cutwidth

#define NOT_LEAF -1
#define PROB 0.5

#define New(type) (type*)malloc(sizeof(type)) 
#define NewArray(type, n) (type*)malloc((n)*sizeof(type)) 

#define LEFT_CHILD 10
#define RIGHT_CHILD 11
#define LEFT_COUSIN 12
#define RIGHT_COUSIN 13

#define PI_RANDOM 1
#define PI_NORMAL 2
#define PI_DFS 3

//GLOBAL VARIABLES

extern int SEPARATE_FLAG;

// Data Structures

typedef int vertex;

// Decomposition Tree Node
typedef struct dt_node
{

  struct dt_node * parent;
  struct dt_node * child[2];       
  vertex v;  //index of node in orig graph;  NOT_LEAF if not a leaf

  int inner_cut;  //Inner Cut Value     
  int lca_flag;   //flag used for lca calculation
  //struct dt_node ** underlying_graph_ref; //underlying graph reference array into dt


  int inner_cut_temp; //Used to hold an inner cut value specific to
                      //a certain node's incident edge set.

  short orientation;  //optimal orientation
  short orientation_worst;//worst orientation
  int subtree_size;  //number of leaves in this subtree


} dt_node;










